package com.jeeplus.sys.controller;

import org.jasig.cas.client.authentication.AttributePrincipal;
import org.jasig.cas.client.validation.Assertion;
import org.jasig.cas.client.validation.Cas20ServiceTicketValidator;
import org.jasig.cas.client.validation.TicketValidationException;
import org.jasig.cas.client.validation.TicketValidator;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

/**
 * @author: 王强
 * @create: 2023-05-05 15:51
 **/
public class CasRestClient {

    public String getCasUserInfo(String ticket,String service,String casServer) throws TicketValidationException {
        //ticket检验器
        TicketValidator ticketValidator = new Cas20ServiceTicketValidator( casServer );
        // 去CAS服务端中验证ticket的合法性
        Assertion casAssertion = ticketValidator.validate ( ticket, service );
        // 从CAS服务端中获取相关属性,包括用户名、是否设置RememberMe等
        AttributePrincipal casPrincipal = casAssertion.getPrincipal ( );
        String loginName = casPrincipal.getName ( );
        return loginName;
    }
}
