package com.jeeplus.config;

import com.jeeplus.common.redis.RedisUtils;
import com.jeeplus.security.config.TestCas;
import com.jeeplus.security.jwt.TokenProvider;
import com.jeeplus.security.util.SecurityUtils;
import com.jeeplus.sys.constant.CacheNames;
import com.jeeplus.sys.controller.CasRestClient;
import com.jeeplus.sys.domain.User;
import com.jeeplus.sys.utils.UserUtils;
import org.apache.commons.io.IOUtils;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.jasig.cas.client.authentication.AttributePrincipal;
import org.jasig.cas.client.session.SingleSignOutHttpSessionListener;
import org.jasig.cas.client.util.AssertionHolder;
import org.jasig.cas.client.validation.Assertion;
import org.jasig.cas.client.validation.Cas20ServiceTicketValidator;
import org.jasig.cas.client.validation.Cas30ServiceTicketValidator;
import org.jasig.cas.client.validation.TicketValidator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContext;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.web.authentication.WebAuthenticationDetails;
import org.springframework.security.web.authentication.logout.SecurityContextLogoutHandler;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.*;
import java.nio.charset.StandardCharsets;
import java.security.Principal;
import java.util.List;
import java.util.Map;

import static org.jasig.cas.client.util.AbstractCasFilter.CONST_CAS_ASSERTION;

/**
 * cas验证是否登录-拦截器
 * @author: 王强
 * @create: 2023-04-24 15:25
 **/
public class MyInterceptor implements HandlerInterceptor {
    @Autowired
    private RedisUtils redisUtils;

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        //使用SecurityContextHolder获取当前的安全上下文
        SecurityContext securityContext = SecurityContextHolder.getContext();
        //获取当前用户的认证详情
        WebAuthenticationDetails details = (WebAuthenticationDetails) SecurityContextHolder.getContext()
                .getAuthentication().getDetails();
        //获取会话id
        if (details != null) {
            String sessionId = details.getSessionId();
            System.out.println("sessionId：" + sessionId);
        }

        //从安全上下文中获取认证信息
//        Authentication authentication = securityContext.getAuthentication();
//        if (authentication != null && authentication.isAuthenticated()){
//            //用户已经通过验证
//            System.out.println("用户已经通过验证");
//            Object principal = authentication.getPrincipal();
//            if (principal instanceof User){
//                User user = (User)principal;
//                System.out.println("验证通过后的用户信息：" + user);
//            }
//        }


//        if (TestCas.is) {
////            if (null != name && name.equals("logout")){
////                //调用前端的退出页面，退出页面默认执行退出功能
////                response.sendRedirect("http://127.0.0.1:3000/CasLogout#/casLogout");
////                return false;
////            }
////        }
//        }

        // 在请求处理之前调用
        //重新发送一个前端的登录请求
//        Authentication auth = SecurityUtils.getAuthentication ();
//        String name = TestCas.name;
//        if (null != name && name.equals("logout")){
//            //删除用户信息
//            HttpSession session = request.getSession();
//            session.invalidate();
//            UserUtils.deleteCache (UserUtils.getCurrentUserDTO () );
//            TestCas.name = null;
//            TestCas.urlName = null;
//            session.invalidate();
//            new SecurityContextLogoutHandler ( ).logout ( request, response, auth );
//            return false;
//        }

//        String loginUrl = "http://www.casserver.com:8443/login?service=http://127.0.0.1:3000/#/casLogin";
        // 指定需要验证的服务的URL
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {
        // 在请求处理之后调用，但是在视图被渲染之前（Controller方法调用之后）
    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {
        // 在请求处理之后调用，在视图被渲染之后（一定会被调用，即使发生异常）
    }
}
